{
Komponente  : TMultiDebugWindow
Dateien     : mdebwin.pas (Source)
              mdebwin.dcu (Compilat)
Stand       : 18.2.1996
              26.7.1996 Angepasst fr Delphi 2
Erstellt    : Kurt Spitzley, (101.10490@germanynet.de or Kurt.Spitzley@rz-online.de)
              Hinweise zur Ausgabeumleitung von Kiriakos Vlahos
Copyright   : Diese Software darf zu nichtkommerziellen Zwecken frei genutzt
              und weitergegeben werden. Kommerzielle Nutzung nur mit ausdrck-
              licher Genehmigung des Autors.

Beschreibung :
--------------
Beim Austesten neuer Programme mchte man oftmals den aktuellen Wert
bestimmter Variablen oder Ausdrcke whrend des Probelaufs ausgeben. Das geht
zwar alles recht einfach mit den vorhandenen Ausgabekomponenten, doch bentigen
diese typ-spezifische Eingaben (bsw. Strings). Die Standard-Pascal Prozedur
"writeln" erledigt Formatierung und Typumwandlung von alleine und ist sehr
einfach zu handhaben.
TMultiDebugWindow ist eine Komponente, welche die Standard-Ausgabe auf sich,
d.h. auf eines ihrer TListBox-Objekte umleitet.Die Fensterbreite wird automatisch
an den lngsten,ausgegebenen Text angepasst.

Die Handhabung von DebugWindow ist extrem einfach:
- TMultiDebugWindow-Komponente auf das Formularfenster des neuen Projekts legen
- Ausgaben mit "writeln" werden ab sofort in einem Debug-Fenster angezeigt.
- Standardmig wird nur ein Debug-Fenster erzeugt
  (Property MultiChannel:=false)
- Bentigt man mehrere Ausgabekanle, so ist das Property MultiChannel auf true
  zu setzen. Die Writeln-Syntax ndert sich nun dahingehend, da das erste
  Zeichen als Ausgabekanalnummer interpretiert wird.

  Beispiel:  3 Ausgabekanle erzeugen
  1. Multichannel auf true setzen
  2. writeln(#1,'Testausgabe auf Kanal 1') erzeugt automatisch das 1.Fenster
  3. writeln(#2,'Testausgabe auf Kanal 2') erzeugt automatisch das 2.Fenster
  4. writeln(#3,'Testausgabe auf Kanal 3') erzeugt automatisch das 3.Fenster
             ^^--> Ausgabekanalnummer

Auch 'write' (d.h.kein CR/LF am Ende) wird untersttzt. Hierbei werden bis zum
nchsten 'writeln' (d.h. CR/LF am Ende) die Daten in jedem Debugfenster
gepuffert.

Dazu folgendes Beispiel:

write(#1,'a'); write(#2,'d'); write(#3,'g'); noch keine Fensterausgabe
write(#1,'b'); write(#2,'e'); write(#3,'h'); noch keine Fensterausgabe
write(#1,'c'); write(#2,'f'); write(#3,'i'); noch keine Fensterausgabe
writeln(#1); writeln(#2); writeln(#3); jetzt Fensterausgabe


Weitere Merkmale:

Stop/Start-Button:
Die Ausgabe kann angehalten bzw. fortgesetzt werden. Neue Daten werden jedoch
weiterhin im Hintergrund aufgezeichnet und nichts geht verloren.

Clear-Button:
Die Datenliste wird gelscht.

LineCounter-Panel:
Anzahl gespeicherter Zeilen im Debug-Fenster

Menpunkte Datei speichern/laden:
Die Datenlisten knnen auf Festplatte gespeichert und wieder geladen werden.

Properties:
-----------
XMaxWin: Maximale Anzahl Fenster horizontal
YMaxWin: dto. vertikal

Methoden:
---------
keine

Events:
-------
keine

================================================================================

Scope       : Simple output to a multiple debugging-windows via Pascal's
              standard-command 'write(ln)'
Component   : TMultiDebugWindow
Files       : mdebwin.pas (Source)
              mdebwin.dcu (Compilat)
Last changes: 18.2.1996 first release
              26.7.1996 adapted to Delphi 2
Author      : Kurt Spitzley, email 0225438-0001@t-online.de
              Thanks to Kiriakos Vlahos I/O-redirection tips
Copyright   : (c) 1996 by Kurt Spitzley, All rights reserved.
              This software should not be SOLD by anyone. It is distributed as
              freeware and therefore may be used free of charge.
Disclaimer  : I have provided this software to the public free of charge. You
              accept this software AS IS without any representation or warranty
              of any kind, including but not limited to the warranty of
              merchantability or fitness for a particular purpose.

Description :
-------------
While debugging new programs it's often useful to have a look at the value's of
special variables or expressions whilest in a realtime test-run. Naturally you
can use Delphi's build-in debugging features, but a quick and dirty way is to do
this via Pascal's standard command write(ln) with it's broad range of formatting
and typecasting features.
TMultiDebugWindow is a component, which redirect's standard-output onto itself,
that means onto a internal TListBox-Object.
It's window-width is automatically adapted to the longest received text.

Handling of TDebugWindow is extremely simple:
- Click a TMultiDebugWindow-Component onto your form
- From now writeln-output can be seen in a debugging-window
- On default one debugging-window will be created
  (Property MultiChannel:=false)
- Do you need more Output-Channels, set property MultiChannel to true.
  Now in your writeln-command the first character is interpreted as channel-no.

  Example:  Create 3 channels
  1. Set Multichannel to true
  2. writeln(#1,'Test on channel 1') automatically creates first window
  3. writeln(#2,'Test on channel 2') automatically creates second window
  4. writeln(#3,'Test on channel 3') automatically creates third window
             ^^--> Channel-Number

'write' (means no CR/LF at the end) is supported. Till the next 'writeln'
(means CR/LF at the end) data is buffered.

See the example:

write(#1,'a'); write(#2,'d'); write(#3,'g'); nothing to see...
write(#1,'b'); write(#2,'e'); write(#3,'h'); nothing to see...
write(#1,'c'); write(#2,'f'); write(#3,'i'); nothing to see...
writeln(#1); writeln(#2); writeln(#3); output is triggered

Other features:

Stop/Start-Button:
Stop and start output. New data is recorded in the background and nothing will
be lost.

Clear-Button:
Clear window.

LineCounter-Panel:
No of stored lines

Menu-topics Save File / Load File
Save/load data to/from harddisk.

Properties:
-----------
XMaxWin: Maximum number of window's horizontal
YMaxWin: vertical

Methods:
--------
none

Events:
-------
none

}

unit Mdebwin;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Menus;

type
  TMDebForm = class(TForm)
    DebugListBox: TListBox;
    Panel1: TPanel;
    Menu: TMainMenu;
    Datei1: TMenuItem;
    Datenspeichern1: TMenuItem;
    Datenladen1: TMenuItem;
    Hilfe1: TMenuItem;
    N1: TMenuItem;
    Info1: TMenuItem;
    Inhalt1: TMenuItem;
    BtnClear: TButton;
    DlgSaveData: TSaveDialog;
    DlgLoadData: TOpenDialog;
    N2: TMenuItem;
    Beeenden1: TMenuItem;
    PnlStartStop: TPanel;
    Bevel1: TBevel;
    LineCnt: TLabel;
    Label1: TLabel;
    procedure BtnClearClick(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Datenspeichern1Click(Sender: TObject);
    procedure Datenladen1Click(Sender: TObject);
    procedure Beeenden1Click(Sender: TObject);
    procedure PnlStartStopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    LineCounter:longint;
    MaxTextWidth:word;
    InpBuf:string;
  end;

  TMultiDebugWindow = class (TComponent)
  private
    FXMaxWin,
    FYMaxWin:byte;
    FMultiChannel:boolean;
    procedure SetXMaxWin(MaxWin:byte);
    procedure SetYMaxWin(MaxWin:byte);
    procedure SetMultiChannel(value:boolean);
  protected
  public
    constructor Create(AOwner:TComponent); override;
    destructor Destroy;override;
  published
    property MultiChannel:boolean read FMultiChannel write SetMultiChannel;
    property XMaxWin:byte read FXmaxWin write SetXMaxWin;
    property YMaxWin:byte read FYmaxWin write SetYMaxWin;
  end;

  EditData = record
    Edit: TListBox;
    Filler: Array [1..12] of Char;
  end;

  TDW =
    record
      XMaxWin,
      YMaxWin:byte;
      DWHeight,
      DWWidth:word;
      MultiChannel:boolean;
      DebugWindowList: TList;
      ActiveDebugWindow:TMDebForm;
      NoOfActiveDebugWindow,
      NoOfLastActiveDebugWindow:word;
    end;

procedure Register;

var
  DW: TDW;

implementation

procedure RedirectSysOutputToDebugWin(WinNumber:word);forward;

{$R *.DFM}

procedure Register;
begin
  RegisterComponents('KSDKB',[TMultiDebugWindow]);
end;

procedure TMDebForm.BtnClearClick(Sender: TObject);
begin
  DebugListBox.Items.Clear;
  LineCounter:=0;
  LineCnt.Caption:='0';
  MaxTextWidth:=0;
end;

procedure TMDebForm.Info1Click(Sender: TObject);
begin
  MessageDlg('DebugWindow 1.2.96'#10'von Kurt Spitzley'#10'DK8PI@DB0lj', mtInformation,[mbOK], 0);
end;

procedure TMDebForm.Datenspeichern1Click(Sender: TObject);
begin
  if DlgSaveData.Execute then
    DebugListBox.Items.SaveToFile(DlgSaveData.Filename);
end;

procedure TMDebForm.DatenLaden1Click(Sender: TObject);
var
  ShowData: TForm;
  DataBox: TListBox;
begin
 if DlgLoadData.Execute then
 begin
   ShowData:=TForm.Create(self);
   with ShowData do
     begin
       DataBox:=TListBox.Create(ShowData);
       DataBox.Parent:=ShowData;
       DataBox.Align:=AlClient;
       DataBox.Items.LoadFromFile(DlgLoadData.Filename);
       ShowModal;
       Visible:=true;
       DataBox.Free;
       Free;
     end;
 end;
end;

procedure TMDebForm.Beeenden1Click(Sender: TObject);
begin
  Close;
end;

procedure TMDebForm.PnlStartStopClick(Sender: TObject);
begin
  with PnlStartStop do
  if Caption='Stop' then
    begin
      Caption:='Start';
      Color:=clRed;
    end
  else
    begin
      Caption:='Stop';
      Color:=clGreen;
    end;
end;

procedure CreateDebugWindow;
begin
  with DW do
  if (MultiChannel and (DebugWindowList.Count<XMaxWin*YMaxWin))or
     (DebugWindowList.Count=0) then
    begin
      DebugWindowList.Add(TMDebForm.Create(Application));
      RedirectSysOutputToDebugWin(DebugWindowList.Count);
      with ActiveDebugWindow do
        begin
          Left:=((NoOfActiveDebugWindow-1)div YMaxWin)*DWWidth;
          Top:=(NoOfActiveDebugWindow-1)mod YMaxWin*DWHeight;
          Width:=DWWidth;
          Height:=DWHeight;
          Caption:='MDebWin '+IntToStr(NoOfActiveDebugWindow);
          Visible:=true;
        end;
    end;
end;

function EditIgnore(var F: TTextRec): Integer; far;
begin
  EditIgnore := 0;
end;

function EditWrite(var F: TTextRec): Integer; far;
var
  s:string;
  w,ChanNo:word;
  ActTextWidth:word;
begin
  with DW do
    begin
      with F do
        begin
          {Delphi1: move(BufPtr^[0],s[1],BufPos);} {temporren String erzeugen}
          {Delphi1: s[0]:=chr(BufPos);} {Stringlngenbyte setzen}
          pchar(BufPtr+BufPos)^ := #0;{temporren String erzeugen}
          s:=StrPas(PChar(BufPtr));
          {Delphi1: if MultiChannel then}
          if MultiChannel and (s<>'') then
            begin
              NoOfLastActiveDebugWindow:=NoOfActiveDebugWindow;
              ChanNo:=ord(s[1]); {Stringbyte 1 enthlt Kanalnummer}
              {Delphi1: dec(s[0]);} {Kanalnummer aus String entfernen}
              {Delphi1: move(s[2],s[1],integer(s[0]));}
              s:=copy(s,2,length(s)-1);{Kanalnummer aus String entfernen}
              {Kanalnummer grer als Anzahl existierender Fenster?
               ->neue Debugfenster erzeugen
               Kanalnummer grer als maximal zulssig ?
               ->kein neues Fenster erzeugen Ausgabe und Ausgabe mit
               Kennung "Kanal xx" in existierendes Fenster leiten}
              if ChanNo in [1..(XMaxWin*YMaxWin)] then
                begin
                 for w:= DebugWindowList.Count+1 to ChanNo do
                    CreateDebugWindow;
                  if NoOfLastActiveDebugWindow<>ChanNo then
                    RedirectSysOutputToDebugWin(ChanNo);
                end
              else
                s:='Kanal '+IntToStr(ChanNo)+': '+s;
            end;
          with ActiveDebugWindow do
            {Delphi1: if s[word(s[0])-1]=#13 then} {writeln (d.h. CR/LF am Ende) ?}
            if (length(s)<>0)and(s[length(s)]=#10) then {writeln (d.h. CR/LF am Ende) ?}
              begin
               inc(LineCounter);
                LineCnt.Caption:=IntToStr(LineCounter);
                {Delphi1: dec(s[0],2);} {CR/LF abschneiden}
                s:=copy(s,1,length(s)-2); {CR/LF abschneiden}
                ActTextWidth:=DebugListBox.Canvas.TextWidth(InpBuf+s);
                if ActTextWidth>=MaxTextWidth then
                  begin
                    MaxTextWidth:=ActTextWidth+9;
                    ActiveDebugWindow.Width:=MaxTextWidth+60;
                  end;
                {Delphi1: EditData(F.UserData).Edit.Items.Add(InpBuf+s);}
                ActiveDebugWindow.DebugListBox.Items.Add(InpBuf+s);
                InpBuf:='';{Fenster-eigenen Textpuffer leeren}
              end
             else
              InpBuf:=InpBuf+s; {write(d.h. kein CR/LF):Text zwischenpuffern}
          BufPos := 0; {Globalen Ausgabepuffer leeren}
        end;
      if ActiveDebugWindow.PnlStartStop.Caption='Stop' then
        ActiveDebugWindow.DebugListBox.ItemIndex:=
          ActiveDebugWindow.DebugListBox.Items.Count-1;
      EditWrite := 0;
    end;
end;

function EditOpen(var F: TTextRec): Integer; far;
begin
  with F do
  begin
    Mode := fmOutput;
    InOutFunc := @EditWrite;
    FlushFunc := @EditWrite;
    EditOpen := 0;
  end;
end;

procedure RedirectSysOutputToDebugWin(WinNumber:word);
begin
  with DW do
  if WinNumber<=DebugWindowList.Count then
    begin
      with TTextRec(System.Output) do
      begin
        NoOfActiveDebugWindow:=WinNumber;
        ActiveDebugWindow:=TMDebForm(DebugWindowList.Items[WinNumber-1]);
        Handle := $FFFF;
        Mode := fmClosed;
        BufSize := SizeOf(Buffer)-1;
        BufPtr := @Buffer;
        OpenFunc := @EditOpen;
        CloseFunc := @EditIgnore;
        Name[0] := #0;
        {Delphi1: EditData(UserData).Edit:=ActiveDebugWindow.DebugListBox;}
      end;
      Rewrite(System.Output);
    end;
end;

procedure AdjustForms;
var w:word;
begin
  with DW do
    if DebugWindowList.Count<>0 then
      for w:=0 to DebugWindowList.Count-1 do
        with TMDebForm(DebugWindowList.Items[w]) do
        begin
          Left:=(w div YMaxWin)*DWWidth;
          Top:=w mod YMaxWin*DWHeight;
          Width:=DWWidth;
          Height:=DWHeight;
        end;
end;

constructor TMultiDebugWindow.Create(AOwner:TComponent);
var w:word;
begin
  if AOwner.ComponentCount<>0 then
    for w:= 0 to AOwner.ComponentCount-1 do
      if AOwner.Components[w] is TMultiDebugWindow then
        begin
          MessageDlg('Nur eine TMultiDebugWindow-Instanz ist erlaubt',
          mtWarning,[mbOK], 0);
        end;
  inherited Create(AOwner);
  MultiChannel:=false; {false: nur 1 Debug-Fenster; true: mehrere mglich}
  DW.DebugWindowList:=TList.Create;
  XMaxWin:=4;
  YMaxWin:=1;
  if not (csDesigning in ComponentState) then
    CreateDebugWindow;
end;

destructor TMultiDebugWindow.Destroy;
begin
  DW.DebugWindowList.Free; //neu fr Delphi 2
  inherited Destroy;
end;

procedure TMultiDebugWindow.SetMultiChannel(Value:boolean);
begin
  FMultiChannel:=Value;
  DW.MultiChannel:=Value;
end;

procedure TMultiDebugWindow.SetXMaxWin(MaxWin:byte);
begin
  with DW do
  if MaxWin in [1..10] then
    begin
      FXMaxWin:=MaxWin;
      XMaxWin:=MaxWin;
      DWWidth:=Screen.Width div XMaxWin;
      if DWWidth<217 then DWWidth:=217;
      if not (csDesigning in ComponentState) then
        AdjustForms;
    end;
end;

procedure TMultiDebugWindow.SetYMaxWin(MaxWin:byte);
begin
  with DW do
  if MaxWin in [1..10] then
    begin
      FYMaxWin:=MaxWin;
      YMaxWin:=MaxWin;
      DWHeight:=Screen.Height div YMaxWin;
      if not (csDesigning in ComponentState) then
        AdjustForms;
    end;
end;

procedure TMDebForm.FormCreate(Sender: TObject);
begin
  LineCounter:=0;
  MaxTextWidth:=0;
  InpBuf:='';
end;

procedure TMDebForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose:=false;
end;

end.

